﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestTreeCtrl
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'database1DataSet.submaster' table. You can move, or remove it, as needed.
            this.submasterTableAdapter.Fill(this.database1DataSet.submaster);
            // TODO: This line of code loads data into the 'database1DataSet.master' table. You can move, or remove it, as needed.
            this.masterTableAdapter.Fill(this.database1DataSet.master);
            //
            AddTreeInfo();
        }

        string[] parentString = { "son1", "son2", "son3", "son4" };
        string[] childString = { "byoung1", "byoung2", "byoung3" };

        private void button1_Click(object sender, EventArgs e)
        {
            treeView1.Nodes.Clear();
            treeView1.BeginUpdate();

            foreach (string str in parentString)
            {
                TreeNode tn = treeView1.Nodes.Add(str);

                foreach (string substr in childString)
                {
                    tn.Nodes.Add(substr);
                }
            }

            treeView1.EndUpdate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            treeView1.Nodes.Clear();
            treeView1.BeginUpdate();

            foreach (string str in parentString)
            {
                treeView1.Nodes.Add(str);
            }

            foreach (TreeNode tn in treeView1.Nodes)
            {
                foreach (string substr in childString)
                {
                    tn.Nodes.Add(substr);
                }
            }

            treeView1.EndUpdate();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            treeView1.Nodes.Clear();
            treeView1.BeginUpdate();

            TreeNode tn = new TreeNode();
            foreach (string str in childString)
            {
                tn.Nodes.Add(str);
            }

            foreach (string str in parentString)
            {
                TreeNode tnParent = treeView1.Nodes.Add(str);
            }

            treeView1.EndUpdate();
        }

        private void AddTreeInfo()
        {
            treeView1.Nodes.Clear();
            treeView1.BeginUpdate();

            foreach (DataRow rowCompany in database1DataSet.master.Rows)
            {
                TreeNode tn = treeView1.Nodes.Add((string)rowCompany["Company"]);

                foreach (DataRow rowBook in rowCompany.GetChildRows("master_submaster"))
                {
                    tn.Nodes.Add((string)rowBook["book_name"]);
                }
            }

            treeView1.EndUpdate();
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode tnNode = treeView1.SelectedNode;
            int fildIdx = 0;
            foreach (DataRow rowCompany in database1DataSet.master.Rows)
            {
                string test = (string)rowCompany["Company"];
                if ((string)rowCompany["Company"] == tnNode.Text)
                    masterBindingSource.Position = fildIdx;
                fildIdx++;
            }
        }
    }
}
